#include <stdio.h>
#include <stdlib.h>

typedef struct _podmornica{
    int a, b;
    int kolicina;
}podmornica;


/*FUNKCIJA ZA USPOREDJIVANJE VARIJABLI TIPA podmornica*/
int usporedi_podmornica (podmornica x, podmornica y)
{
    if(x.a-y.a || x.b-y.b || x.kolicina-y.kolicina)
        return 0;

    return 1;
}

/*POMOCNA FUNKCIJA KOJA SLUZI DA U NIZ podmornice UNESEMO NOVU
PODMORNICU TIPA axb (AKO VEC POSTOJI PODMORNICA TOG TIPA, SAMO
KOLICINU POVECAMO ZA 1)*/
/*NIZ podmornice PRENOSIMO PO ADRESI JER GA U NEKIM SLUCAJEVIMA
MIJENJAMO (KORISTIMO realloc)*/
void unesi_podmornicu(podmornica** podmornice, int* br, int a, int b)
{
    int i;

    /*PROVJERAVAMO IMAMO LI VEC PODMORNICU TIPA axb*/
    for(i=0; i<*br; i++){
        if((*podmornice)[i].a==a && (*podmornice)[i].b==b){
            (*podmornice)[i].kolicina++;
            return;
        }
    }

    /*AKO NEMA TAKVE PODMORNICE, DODAJEMO NOVU CELIJU*/
    *podmornice=(podmornica*)realloc(*podmornice,++(*br)*sizeof(podmornica));
    (*podmornice)[*br-1].a=a;
    (*podmornice)[*br-1].b=b;
    (*podmornice)[*br-1].kolicina=1;
}


/*POMOCNA FUNKCIJA KOJA NAM ZA SVAKO POJAVLJIVANJE ZNAKA '*' VRACA DIMENZIJU
PODMORNICE U KOJOJ SE NALAZI TO POLJE*/
void dimenzija_podmornice (char** ploca, int n, int i, int j, int* a, int* b)
{
    int k=0;
    int l=0;

    /*ISPITUJEMO LIJEVO I DESNO OD MJESTA (i,j)*/
    while(++k+j<n && ploca[i][j+k]=='*');
    while(++l-j<=0 && ploca[i][j-l]=='*');
    *b=k+l-1;


    k=0;
    l=0;
    /*ISPITUJEMO GORE I DALJE OD MJESTA (i,j)*/
    while(++k+i<n && ploca[i+k][j]=='*');
    while(++l-i<=0 && ploca[i-l][j]=='*');
    *a=k+l-1;

    if(*a>*b){
        k=*a;
        *a=*b;
        *b=k;
    }
}


/*NIZ podmornice PRI KREIRANJU NIJE SORTIRAN PA GA SORTIRAMO DA LAKSE
USPOREDIMO NIZ DOBIVEN IZ PRVE I DRUGE PLOCE*/
void sortiraj_podmornice (podmornica* podmornice, int br)
{
    int i, j, kriterij;
    podmornica tmp;

    for(i=0; i<br-1; i++){
        for(j=i+1; j<br; j++){
            /*NAJPRIJE PO a, A ZATIM PO b*/
            kriterij=(podmornice[i].a>podmornice[j].a)||
                (podmornice[i].a==podmornice[j].a && podmornice[i].b>podmornice[j].b);
            if(kriterij){
                tmp=podmornice[i];
                podmornice[i]=podmornice[j];
                podmornice[j]=tmp;
            }
        }
    }
}


/*FUNKCIJA KOJOM PROLAZIMO PO PLOCI SPREMLJNOJ U DVODIMENZINALNO DINAMICKI ALOCIRANO
POLJE charova I PREKO VARIJABILNOG ARUGMENTA VRACAMO NIZ podmornice I NJEGOVU DULJINU br.*/
/*NIZ podmornice IMA ONOLIKO ELEMENATA KOLIKO NA PLOCI IMA RAZLICITNIH TIPOVA PODMORNICA*/
void pregled_matrice (char** ploca, int n, podmornica** podmornice, int* br)
{
    int i, j;
    int a, b, tmp;

    for(i=0; i<n; i++){
        for(j=0; j<n; j++){
            if(ploca[i][j]=='*'){
                dimenzija_podmornice(ploca,n,i,j,&a,&b);
                //printf("(%d,%d) podmornica dim. %dx%d\n", i,j,a,b);
                unesi_podmornicu(podmornice,br,a,b);
            }
        }
    }

    /*SVAKU PODMORNICU BROJIMO ONOLIKO PUTA KOLIKA JOJ JE POVRSINA PA TO POPRAVLJAMO*/
    for(i=0; i<*br; i++){
        (*podmornice)[i].kolicina/=(*podmornice)[i].a*(*podmornice)[i].b;
    }

    /*SORTIRAMO PODMORNICE PO VELICINI*/
    sortiraj_podmornice(*podmornice,*br);
}


/*SAMO ZA PROVJERU*/
void ispis_matrice(char** ploca, int n)
{
    int i, j;

    for(i=0; i<n; i++){
        for(j=0; j<n; j++){
            printf("%c", ploca[i][j]);
        }
        printf("\n");
    }
    printf("\n\n");
}


int main(void)
{
    FILE *in1, *in2;
    int n, i, j, br1=0, br2=0;
    char **ploca1, **ploca2;
    char x;
    podmornica *podmornice1=NULL, *podmornice2=NULL;

    /*OTVARAMO DATOTEKE U KOJOJ SU PLOCE*/
    in1=fopen("igrac1.txt","rt");
    if(!in1) return printf("Problem s datotekom igrac1.txt!\n");
    in2=fopen("igrac2.txt","rt");
    if(!in2) return printf("Problem s datotekom igrac2.txt!\n");

    /*CITAMO DIMENZIJU PLOCA I PREKIDAMO PROGRAM AKO NISU ISTE DIMENZIJE*/
    fscanf(in1, "%d", &n);
    fscanf(in2, "%d", &i);
    if(n!=i)
        return printf("Tablice nisu kompatibilne: problem 1\n");

    /*CITAMO CIJELE PLOCE I SPREMAMO IH U ploca1 I ploca2*/
    ploca1=(char**)malloc(n*sizeof(char*));
    for(i=0; i<n; i++)
        ploca1[i]=(char*)malloc(n*sizeof(char));

    ploca2=(char**)malloc(n*sizeof(char*));
    for(i=0; i<n; i++)
        ploca2[i]=(char*)malloc(n*sizeof(char));

    fscanf(in1,"%c",&x); /*CITAMO ZNAK ZA NOVI RED KOJI NAM NE TREBA*/
    fscanf(in2,"%c",&x);
    for(i=0; i<n; i++){
        for(j=0; j<n; j++){
           fscanf(in1, "%c", &ploca1[i][j]);
           fscanf(in2, "%c", &ploca2[i][j]);
        }
        fscanf(in1,"%c",&x); /*CITAMO ZNAK ZA NOVI RED KOJI NAM NE TREBA*/
        fscanf(in2,"%c",&x);
    }

    /*PROVJERA*/
    ispis_matrice(ploca1,n);
    ispis_matrice(ploca2,n);

    /*VISE NE TREBAMO DATOTEKE PA IH ZATVARAMO*/
    fclose(in1);
    fclose(in2);

    /*OBRADJUJEMO PLOCICE*/
    pregled_matrice(ploca1,n,&podmornice1,&br1);
    pregled_matrice(ploca2,n,&podmornice2,&br2);

    /*MATRICE NAM VISE NE TREBAJU PA IH DEALOCIRAMO*/
    for(i=0; i<n; i++){
        free(ploca1[i]);
        free(ploca2[i]);
    }
    free(ploca1);
    free(ploca2);

    /*ISPITUJEMO JESU LI KOMPATIBILNE (JEDNAK BROJ PODMORNICA ISTOG TIPA)*/
    /*NAJPRIJE GLEDAMO IMAJU LI JEDNAK BROJ RAZLICITIH TIPOVA PODMORNICA*/
    j=1;
    if(br1!=br2)
        j=0;
    /*SAD GLEDAMO IMAJU LI JEDNAK BROJ PODMORNICA ISTOG TIPA*/
    for(i=0; j && i<br1; i++)
        if(!usporedi_podmornica(podmornice1[i],podmornice2[i])){
            j=-1;
            break;
        }

    /*U VARIJABLI j JE SPREMLJENA SVA INFORMACIJA TAKO DA MOZEMO DEALOCIRATI
    NIZOVE podmornice1 I podmornice2*/
    free(podmornice1);
    free(podmornice2);

    /*SLUCAJEVI j=0 I j=-1 NISU DOBRI*/
    if(!j)
        return printf("Tablice nisu kompatibilne: problem 2 (br1=%d, br2=%d)\n", br1, br2);
    if(j==-1)
        return printf("Tablice nisu kompatibilne: problem 3\n");

    return 0;
}
